Complexity:
Is Regression: No
Subject: displayCond should allow userFunc as condition
Description

Would be great to have userFuncs usable in TCA displayCond.
By this it would be possible to have custom rules implemented wether a field should get shown or not

Related issues:
duplicated by Core - Feature # 46460: Introduce TCA displayCond type "USER" Resolved 2013-03-20

Associated revisions
Revision cdcf56c8 - 2015-01-03 15:11 - Sebastian Fischer

[FEATURE] displayCond should allow userFunc as condition

This patch enables the usage of a displayCond defined as
'USER:\Example\Namespace\UserClass->functionName:any:other:parameter'

Releases: master
Resolves: #62944
Change-Id: I9e915e9098494715a3fb5961836af6b16eb12b27
Reviewed-on: http://review.typo3.org/34728
Reviewed-by: Anja Leichsenring <aleichsenring@ab-softlab.de>
Tested-by: Anja Leichsenring <aleichsenring@ab-softlab.de>
Reviewed-by: Benjamin Mack <benni@typo3.org>
Tested-by: Benjamin Mack <benni@typo3.org>

History
#1 - 2014-11-21 16:43 - Sebastian Fischer

The userFunc should get handed the following informations:
if new:
-tablename
-fieldname
-fieldconfig
-currentPageId

if already saved once:
-tablename
-fieldname
-fieldconfig
-currentPageId
-currentRecordData

Return Value would be boolean as its just a decision if the field should be displayed or not.
The userFunc should be called with TYPO3\CMS\Core\Utility\GeneralUtility::callUserFunction to have the same handling like every other userfunc

Example for a configuration would be
'displayCond' => 'USER:\Example\Namespace\UserClass->functionName:REQ:true',

#2 - 2014-11-21 16:56 - Benjamin Mack

Want to implement this? Would be great!

#3 - 2014-11-28 09:58 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/34728

#4 - 2014-12-03 11:05 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/34728

#5 - 2014-12-05 08:49 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/34728

#6 - 2015-01-03 14:17 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/34728

#7 - 2015-01-03 15:03 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/34728

#8 - 2015-01-03 15:32 - Wouter Wolters
- Status changed from Under Review to Resolved

#9 - 2015-01-31 15:16 - José Ricardo

As an additional feature, I suggest extending this to sheets.
The solution seems to be simple, just adding the case 'USER': in the switch on method getSingleField_typeFlex at 
TYPO3\CMS\Backend\Form\FormEngine.php
